SystemOrganization addCategory: #'Thiago-Iliad-GuessingGame'!

ILApplication subclass: #ILGuessingGameApplication
	instanceVariableNames: 'sequenceWidget'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thiago-Iliad-GuessingGame'!

!ILGuessingGameApplication class methodsFor: 'accessing' stamp: 'ThiagoLino 3/28/2012 08:58'!
path
	^'guess'! !

!ILGuessingGameApplication methodsFor: 'controllers' stamp: 'ThiagoLino 3/28/2012 09:02'!
index
	^[ :e | 
		e div
			class: 'wrapper';
			build: [ :div |
				div h1: 'Guessing Game'.
				div build: self sequenceWidget ]]! !

!ILGuessingGameApplication methodsFor: 'accessing' stamp: 'ThiagoLino 4/9/2012 10:41'!
sequenceWidget
	^ sequenceWidget ifNil: [ 
		sequenceWidget := ILGuessingGameSequence new  ]! !

!ILGuessingGameApplication methodsFor: 'updating' stamp: 'ThiagoLino 3/28/2012 08:58'!
updatePage: aPage
	super updatePage: aPage.
	aPage head stylesheet href: '/stylesheets/iliad.css'! !

ILWidget subclass: #ILGuessingGameWidget
	instanceVariableNames: 'guess'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thiago-Iliad-GuessingGame'!

!ILGuessingGameWidget methodsFor: 'building' stamp: 'ThiagoLino 4/9/2012 11:17'!
contents
	^[:e |
		e form 
			build: [ :form |
				form text: 'Guess (between 0 and 100):  '.
				form input
					action: [ :val | self guess: val ].
				form button 
					text: 'submit';
					action: [ self answer:  self guess ]]]! !

!ILGuessingGameWidget methodsFor: 'accessing' stamp: 'ThiagoLino 3/28/2012 10:13'!
guess
	^ guess! !

!ILGuessingGameWidget methodsFor: 'accessing' stamp: 'ThiagoLino 3/28/2012 10:13'!
guess: aNumber
	guess := aNumber
! !

ILSequence subclass: #ILGuessingGameSequence
	instanceVariableNames: 'message number'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Thiago-Iliad-GuessingGame'!

!ILGuessingGameSequence methodsFor: 'initialization' stamp: 'ThiagoLino 3/29/2012 16:41'!
initialize 
	super initialize.
	self initializeGame.! !

!ILGuessingGameSequence methodsFor: 'initialization' stamp: 'ThiagoLino 3/29/2012 16:41'!
initializeGame
	number := 100 atRandom.
	message := ''.! !

!ILGuessingGameSequence methodsFor: 'accessing' stamp: 'ThiagoLino 3/29/2012 16:34'!
message
	^ message! !

!ILGuessingGameSequence methodsFor: 'accessing' stamp: 'ThiagoLino 3/29/2012 16:33'!
message: aString
	message := aString
! !

!ILGuessingGameSequence methodsFor: 'accessing' stamp: 'ThiagoLino 3/29/2012 16:33'!
number
	^ number! !

!ILGuessingGameSequence methodsFor: 'accessing' stamp: 'ThiagoLino 3/29/2012 16:33'!
number: aNumber
	number := aNumber
! !

!ILGuessingGameSequence methodsFor: 'control-flow' stamp: 'ThiagoLino 4/9/2012 13:31'!
start
	| guess |
	self 
            show: (ILGuessingGameWidget  new
					addMessage: self message;
					yourself)
            	onAnswer: [ :aGuess | guess := aGuess.
				guess asNumber =  number
					ifTrue: [ 
						self initializeGame.
						self inform: 'You got it!!' ]
					ifFalse: [
						guess asNumber  < number
							ifTrue: [ self message: 'Your guess was too low' ].
						guess asNumber > number
							ifTrue: [ self message: 'Your guess was too high' ].
						guess asNumber =  number. "block must  answer false to continue" ]]
				
			
! !
